#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <crypt.h>
#include <time.h>

char char_for_salt() {
	int r, t1, t2, t3, tot;

	// Genero i caratteri del salt in modo tale che appartengano a uno degli
	// intervalli previsti: ./0..9   a..z   A..Z
	t1 = '9' - '.' + 1;
	t2 = 'z' - 'a' + 1;
	t3 = 'Z' - 'A' + 1;
	tot = t1 + t2 + t3;

	r = rand();
	r = r % tot;
	if(r < t1) return r + '.';
	if(r < t1 + t2) return r - t1 + 'A';
	return r - t1 - t2 + 'a';
}

void create_salt(char salt[]) {

	salt[0] = char_for_salt();
	salt[1] = char_for_salt();

	printf("Salt: %c%c\n", salt[0], salt[1]);
}

int main(int argc,char* argv[]) {

	// Nome del nuovo utente
	char* username;

	// Password in chiaro del nuovo utente
	char* password;

	// Password cifrata del nuovo utente
	char res[512];

	// File delle password
	FILE* fd;

	// Salt
	char salt[2];

	// Contiene la nuova linea del file delle password
	char buf[512];

	// Byte scritti
	ssize_t w;

	// Controllo se ci sono tutti i parametri
	if(argc != 3) {
		printf("Wrong number of parameters\n");
		printf("USAGE: %s username password\n", argv[0]);
		exit(1);
	}

	// Inizializzo il generatore di numeri casuali
	srand(time(NULL));

	// Imposto username e password
	username = argv[1];
	password = argv[2];

	printf("La password in chiaro è %s\n", password);

	// Genero il salt
	create_salt(salt);

	// Cifro la password
	strncpy(res, crypt(password, salt), sizeof(res));

	printf("La password cifrata è %s\n", res);

	// Apro il file delle password
	fd = fopen("mypasswd", "a");
	if(fd == NULL) {
		perror("opening file");
		exit(1);
	}

	// Genero la nuova riga: username password_cifrata
	// I primi due caratteri della password cifrata sono il salt
	snprintf(buf, sizeof(buf), "%s %s\n", username, res);

	// Scrivo la nuova riga nel file
	w = fwrite(buf, 1, strlen(buf), fd);
	if(w != strlen(buf)) {
		perror("fwrite");
		exit(1);
	}

	fclose(fd);
	printf("L'utente è stato aggiunto\n");
	exit(0);
}
